//    ,   
// Proteus (icq:133575351) lawnmower-man@mail.ru
// 

#include<stdio.h>
#include<memory.h>
#include<stdlib.h>

int file_size=0;
unsigned int crc=0;
FILE *input,*output;

//!   
struct list_st{
	int next;	//!<   
	int len;	//!<  
	int code;	//!<  
};

//!   
struct list_list_st{
	int count;	//!<   
	int head;	//!<   
};

list_st list[256];				//!<    
list_list_st list_list[256];	//!<  
int list_list_count=0;			//!<   

int bit_buff=0; int bit_count=0; //    

//!   
void PreLoad()
{
	memset(list_list,0,sizeof(list_list));
	for(;;) {
		unsigned int t=fgetc(input); if(t==EOF) break;
		list_list[t].count++;
		file_size++;
	}
	rewind(input);
}

/*
void DumpList(int l)
{
	int n=list_list[l].head;
	while(n>=0) {
		char t=n; if(t<' ') t=' ';
		printf("%c:%d ",t,list[n].len);
		n=list[n].next;
	}
	printf("[%d]\n",list_list[l].count);
}
//*/

//!      
//! s1,s2      
void MergeList(int s1,int s2)
{
	int next,head,last=-1;	
	int i1=list_list[s1].head;
	int i2=list_list[s2].head;
	while(i1>=0 && i2>=0) {	//    
		if(i2<0 || i1>=0 && list[i1].len<list[i2].len) next=i1,i1=list[i1].next; else next=i2,i2=list[i2].next;
		if(last<0) last=head=next; else
		list[last].next=next,last=next;
	}
	if(i1>0) list[last].next=i1;	//     
	if(i2>0) list[last].next=i2;
	list_list[s1].head=head;
	list_list[s1].count+=list_list[s2].count;    //       
	list_list[s2]=list_list[--list_list_count];
	while(head>=0) list[head].len++,head=list[head].next;	//   
}

//!    (   )
void MergeList()
{
	int min,i1,i2,n;
	while(list_list_count>1) {	//   ,   
		//    (    ,  ?)
		min=file_size+1;
		for(n=0; n<list_list_count; n++) if(min>=list_list[n].count) min=list_list[n].count,i1=n;
		min=file_size+1;
		for(n=0; n<list_list_count; n++) if(n!=i1 && min>=list_list[n].count) min=list_list[n].count,i2=n;
		// 
		MergeList(i1,i2); 
	}
}

//!    (    )
void InitCode()
{
	int len=1,code=0;
	int n=list_list[0].head;
	while(n>=0) {
		if(list[n].len==len) list[n].code=code++,n=list[n].next;
		else code<<=1,len++;
	}
}

#define CODE_LIMIT 16

//!   
//        ,       
void CutLen()
{
	int stack[256]; int sp,n,m,d;
	sp=-1; n=list_list[0].head;
	while(n>=0) {
		if(list[n].len<CODE_LIMIT) stack[++sp]=n;	//    ,      -
		m=n;
		while(list[m].len>CODE_LIMIT) {		//    ,     
			d=list[m].len-CODE_LIMIT;
			list[m].len=CODE_LIMIT;
			m=stack[sp];
			list[m].len+=d;
			if(list[m].len>=CODE_LIMIT) sp--;
		}
		n=list[n].next;
	}
}



//!      
void Init()
{
	int n;
	for(n=0; n<256; n++) {
		list[n].len=0;
		list[n].next=-1;
		list_list[n].head=n;
	}
	for(n=0; n<256; n++) if(list_list[n].count) list_list[list_list_count++]=list_list[n]; //   
	MergeList();	//   
	CutLen();		//   
//	DumpList(0);
	InitCode();		//   
}

//!    
void WriteHead()
{
	int n,array[32],count;
	memset(array,0,sizeof(array));
	for(n=list_list[0].head; n>=0; n=list[n].next) {
		if(list[n].len>=32) {fprintf(stderr,"internal error\n\a"); exit(1);}
		array[list[n].len]++;
		if(list[n].len>count) count=list[n].len;
	}
	for(n=1; n<=count; n++) fputc(array[n],output); fputc(-1,output);
	for(n=list_list[0].head; n>=0; n=list[n].next) fputc(n,output);
	fwrite(&file_size,1,sizeof(file_size),output);
}

//!    
//! \patam n       
void WriteBit(int n)
{
	bit_buff=(bit_buff<<1)|(n&1); bit_count++;
	if(bit_count>=8) fputc(bit_buff,output),bit_count=0;
}

//!   
void WritePack()
{
	for(;;) {
		unsigned int t=fgetc(input); if(t==EOF) break;
		crc=crc*17+t;
		int l=list[t].len;
		while(l) 
		{
			l--;
			WriteBit(list[t].code>>l);
		}

	}
	while(bit_count) WriteBit(0);	//     
	fwrite(&crc,1,sizeof(crc),output);
}


int main(int c,char **l)
{
	if(c!=3) {printf("%s <input_name> <output_name>\n",l[0]); return 2;}
	input=fopen(l[1],"rb");
	output=fopen(l[2],"wb");

	PreLoad();			//  
	Init();				//  
	WriteHead();		//  
	WritePack();		//  

	fclose(input);
	fclose(output);
	return 0;
}



